$SAFE = 2
$CUR = '%0.2f'

# ***** Code Fixes *****
# Overrides some methods in the base class String.
class String
	alias orig_to_f to_f
	alias orig_to_i to_i
	alias string_format %
	def to_f
		delete(',').orig_to_f
	end
	def to_i
		delete(',').orig_to_i
	end
	def %(arg)
		if (arg.kind_of?(Array) or index('f') == nil)
			string_format(arg)
		else
			value = arg.to_f
			string_format(value < 0.0 ? value - 0.00000001 : value + 0.00000001)
		end
	end

end

# ***** Profile Classes *****
class Individual
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def suffix; ''; end
 def address; ''; end
 def apartment_number; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def ssn; ''; end
 def occupation; ''; end
 def county; ''; end
 def school_code; ''; end
 def email; ''; end
 def blind; ''; end
 def sixty_five_plus; ''; end
 def spouse_first_name; ''; end
 def spouse_middle_initial; ''; end
 def spouse_last_name; ''; end
 def spouse_suffix; ''; end
 def spouse_address; ''; end
 def spouse_apartment_number; ''; end
 def spouse_city; ''; end
 def spouse_state; ''; end
 def spouse_zip; ''; end
 def spouse_phone; ''; end
 def spouse_work_phone; ''; end
 def spouse_mobile_phone; ''; end
 def spouse_fax; ''; end
 def spouse_ssn; ''; end
 def spouse_occupation; ''; end
 def spouse_county; ''; end
 def spouse_school_code; ''; end
 def spouse_email; ''; end
 def spouse_blind; ''; end
 def spouse_65_plus; ''; end
 def single; ''; end
 def married_joint; ''; end
 def married_separate; ''; end
 def head_of_household; ''; end
 def widow_widower; ''; end
 def direct_deposit_checking; ''; end
 def direct_deposit_savings; ''; end
 def routing_number; ''; end
 def account_number; ''; end
 def dependent1_first_name; ''; end
 def dependent1_last_name; ''; end
 def dependent1_ssn; ''; end
 def dependent1_relationship; ''; end
 def dependent1_dob; ''; end
 def dependent2_first_name; ''; end
 def dependent2_last_name; ''; end
 def dependent2_ssn; ''; end
 def dependent2_relationship; ''; end
 def dependent2_dob; ''; end
 def dependent3_first_name; ''; end
 def dependent3_last_name; ''; end
 def dependent3_ssn; ''; end
 def dependent3_relationship; ''; end
 def dependent3_dob; ''; end
 def dependent4_first_name; ''; end
 def dependent4_last_name; ''; end
 def dependent4_ssn; ''; end
 def dependent4_relationship; ''; end
 def dependent4_dob; ''; end
 def dependent5_first_name; ''; end
 def dependent5_last_name; ''; end
 def dependent5_ssn; ''; end
 def dependent5_relationship; ''; end
 def dependent5_dob; ''; end
 def dependent6_first_name; ''; end
 def dependent6_last_name; ''; end
 def dependent6_ssn; ''; end
 def dependent6_relationship; ''; end
 def dependent6_dob; ''; end
 def business_name; ''; end
 def business_address; ''; end
 def business_address2; ''; end
 def business_city; ''; end
 def business_state; ''; end
 def business_zip; ''; end
 def fein; ''; end
 def business_phone; ''; end
 def business_fax; ''; end
 def business_email; ''; end
end

class Preparer
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def firm_name; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def ptin; ''; end
 def ssn; ''; end
 def self_employed; ''; end
end

class Entity
 def name; ''; end
 def address; ''; end
 def address2; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def state_id; ''; end
 def date_started; ''; end
 def state_of_incorporation; ''; end
 def naics_code; ''; end
 def principal_activity; ''; end
 def contact_name; ''; end
 def contact_title; ''; end
 def contact_phone; ''; end
 def estate_name; ''; end
 def estate_ssn; ''; end
 def estate_dod; ''; end
 def agent_first_name; ''; end
 def agent_middle_initial; ''; end
 def agent_last_name; ''; end
 def agent_business_name; ''; end
 def agent_address; ''; end
 def agent_city; ''; end
 def agent_state; ''; end
 def agent_zip; ''; end
 def agent_phone; ''; end
end

class Fiduciary
 def first_name_and_mi; ''; end
 def last_name; ''; end
 def title; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def ssn; ''; end
 def estate_name; ''; end
 def ein; ''; end
 def entity_creation_date; ''; end
 def entity_type_decendents; ''; end
 def entity_type_simple; ''; end
 def entity_type_complex; ''; end
 def entity_type_disability; ''; end
 def entity_type_esbt; ''; end
 def entity_type_grantor; ''; end
 def entity_type_bankruptcy_ch7; ''; end
 def entity_type_bankruptcy_ch11; ''; end
 def entity_type_pooled_income; ''; end
 def decedent_first_name_and_mi; ''; end
 def decedent_last_name; ''; end
 def decedent_address; ''; end
 def decedent_city; ''; end
 def decedent_state; ''; end
 def decedent_zip; ''; end
 def decedent_phone; ''; end
 def decedent_ssn; ''; end
 def decedent_dob; ''; end
 def decedent_dod; ''; end
end

class Equifax
def account_name; ''; end
def unemp_tax_yes; ''; end
def unemp_tax_no; ''; end
def local_wh_tax_yes; ''; end
def local_wh_tax_no; ''; end
def wh_tax_yes; ''; end
def wh_tax_no; ''; end
def emp_tax_consult_yes; ''; end
def emp_tax_consult_no; ''; end
def open_new_business; ''; end
def exist_entity_new_in_state; ''; end
def acquire_exist_business; ''; end
def reopen_inactiv_business; ''; end
def change_owner_type_entity; ''; end
def name_change; ''; end
def acct_closures; ''; end
def other_checkbox; ''; end
def other_list; ''; end
def succ_business_name; ''; end
def succ_trade_dba; ''; end
def succ_fein; ''; end
def succ_phone; ''; end
def succ_corp_address; ''; end
def succ_corp_address2; ''; end
def succ_corp_city; ''; end
def succ_corp_state; ''; end
def succ_corp_zip; ''; end
def succ_mailing_address; ''; end
def succ_mailing_address2; ''; end
def succ_mailing_city; ''; end
def succ_mailing_state; ''; end
def succ_mailing_zip; ''; end
def succ_contact_name; ''; end
def succ_contact_title; ''; end
def succ_contact_phone; ''; end
def succ_contact_fax; ''; end
def succ_contact_email; ''; end
def succ_entity_type_corp_public; ''; end
def succ_entity_type_corp_private; ''; end
def succ_entity_type_partnership; ''; end
def succ_entity_type_ltd_partnership; ''; end
def succ_entity_type_scorp; ''; end
def succ_entity_type_other_checkbox; ''; end
def succ_entity_type_other_list; ''; end
def succ_entity_type_llc; ''; end
def succ_entity_type_taxed_as_corp; ''; end
def succ_entity_type_taxed_as_partnership; ''; end
def succ_entity_type_disregarded_entity; ''; end
def succ_entity_type_disregarded_entity_member_name; ''; end
def succ_entity_type_disregarded_entity_member_fein; ''; end
def succ_entity_type_sole_proprietor; ''; end
def succ_state_of_incorporation; ''; end
def succ_date_started; ''; end
def succ_fiscal_yr_end_date; ''; end
def succ_acctng_method_cash; ''; end
def succ_acctng_method_accrual; ''; end
def succ_first_day_of_employment; ''; end
def succ_first_payroll_date; ''; end
def succ_nature_of_business_retail; ''; end
def succ_nature_of_business_wholesale; ''; end
def succ_nature_of_business_manufacturing; ''; end
def succ_nature_of_business_service; ''; end
def succ_nature_of_business_staffing_temp; ''; end
def succ_nature_of_business_prof_emp_org; ''; end
def succ_nature_of_business_other_checkbox; ''; end
def succ_nature_of_business_other_list; ''; end
def succ_business_activity_description; ''; end
def succ_naics_code; ''; end
def succ_501_c_3_exempt_yes; ''; end
def succ_501_c_3_exempt_no; ''; end
def succ_futa_yes; ''; end
def succ_futa_no; ''; end
def succ_futa_date_first_liability; ''; end
def succ_psp_na; ''; end
def succ_psp_name; ''; end
def succ_psp_contact_name; ''; end
def succ_psp_phone; ''; end
def succ_psp_address; ''; end
def succ_psp_city; ''; end
def succ_psp_state; ''; end
def succ_psp_zip; ''; end
def succ_bank_name; ''; end
def succ_bank_address; ''; end
def succ_bank_city; ''; end
def succ_bank_state; ''; end
def succ_bank_zip; ''; end
def succ_bank_phone; ''; end
def succ_bank_acct_number; ''; end
def succ_empl_other_states_yes; ''; end
def succ_empl_other_states_no; ''; end
def succ_empl_other_states_multiple; ''; end
def succ_break_in_employment_yes; ''; end
def succ_break_in_employment_no; ''; end
def succ_total_payroll_quarter; ''; end
def succ_total_payroll_year; ''; end
def succ_20th_wk_date_emp; ''; end
def succ_parent_company_name; ''; end
def succ_parent_company_fein; ''; end
def succ_officer1_name; ''; end
def succ_officer1_title; ''; end
def succ_officer1_ssn_ein; ''; end
def succ_officer1_address; ''; end
def succ_officer1_city; ''; end
def succ_officer1_state; ''; end
def succ_officer1_zip; ''; end
def succ_officer1_dob; ''; end
def succ_officer1_date_of_appt; ''; end
def succ_officer2_name; ''; end
def succ_officer2_title; ''; end
def succ_officer2_ssn_ein; ''; end
def succ_officer2_address; ''; end
def succ_officer2_city; ''; end
def succ_officer2_state; ''; end
def succ_officer2_zip; ''; end
def succ_officer2_dob; ''; end
def succ_officer2_date_of_appt; ''; end
def succ_officer3_name; ''; end
def succ_officer3_title; ''; end
def succ_officer3_ssn_ein; ''; end
def succ_officer3_address; ''; end
def succ_officer3_city; ''; end
def succ_officer3_state; ''; end
def succ_officer3_zip; ''; end
def succ_officer3_dob; ''; end
def succ_officer3_date_of_appt; ''; end
def pred_name; ''; end
def pred_dba; ''; end
def pred_fein; ''; end
def pred_phone; ''; end
def pred_corp_address; ''; end
def pred_corp_address2; ''; end
def pred_corp_city; ''; end
def pred_corp_state; ''; end
def pred_corp_zip; ''; end
def pred_contact_name; ''; end
def pred_contact_phone; ''; end
def pred_contact_mailing_address; ''; end
def pred_contact_mailing_address2; ''; end
def pred_contact_mailing_city; ''; end
def pred_contact_mailing_state; ''; end
def pred_contact_mailing_zip; ''; end
def pred_transaction_date; ''; end
def pred_operating_at_time_of_purchase_yes; ''; end
def pred_operating_at_time_of_purchase_no; ''; end
def pred_transaction_type_asset_purchase; ''; end
def pred_transaction_type_stock_purchase; ''; end
def pred_transaction_type_company_reorg; ''; end
def pred_transaction_type_salutory_merger; ''; end
def pred_transaction_type_other_checkbox; ''; end
def pred_transaction_type_other_list; ''; end
def pred_transaction_type_employee_reassignment; ''; end
def pred_transaction_type_bankruptcy_acq; ''; end
def pred_transaction_type_entity_conversion; ''; end
def pred_acq_all_employment; ''; end
def pred_acq_partial_employment; ''; end
def pred_emp_agency_yes; ''; end
def pred_emp_agency_no; ''; end
def pred_business_description; ''; end
def pred_succ_commonly_owned_yes; ''; end
def pred_succ_commonly_owned_no; ''; end
def pred_succ_commonly_owned_percent; ''; end
def pred_succ_relationship_described; ''; end
def pred_acquired_assets_acct_rec; ''; end
def pred_acquired_assets_machinery_equip; ''; end
def pred_acquired_assets_furniture_fixtures; ''; end
def pred_acquired_assets_goodwill; ''; end
def pred_acquired_assets_buildings; ''; end
def pred_acquired_assets_stock; ''; end
def pred_acquired_assets_other_real_prop_leases; ''; end
def pred_acquired_assets_customer_lists; ''; end
def pred_acquired_assets_employees; ''; end
def pred_acquired_assets_inventories; ''; end
def pred_will_report_wages_yes; ''; end
def pred_will_report_wages_no; ''; end
def pred_last_date_of_emp; ''; end
def pred_date_of_last_payroll; ''; end
def pred_parent_company_name; ''; end
def pred_parent_company_fein; ''; end
def pred_officer1_name; ''; end
def pred_officer1_title; ''; end
def pred_officer1_ssn_ein; ''; end
def pred_officer1_address; ''; end
def pred_officer1_city; ''; end
def pred_officer1_state; ''; end
def pred_officer1_zip; ''; end
def pred_officer1_dob; ''; end
def pred_officer1_date_of_appt; ''; end
def pred_officer2_name; ''; end
def pred_officer2_title; ''; end
def pred_officer2_ssn_ein; ''; end
def pred_officer2_address; ''; end
def pred_officer2_city; ''; end
def pred_officer2_state; ''; end
def pred_officer2_zip; ''; end
def pred_officer2_dob; ''; end
def pred_officer2_date_of_appt; ''; end
def pred_officer3_name; ''; end
def pred_officer3_title; ''; end
def pred_officer3_ssn_ein; ''; end
def pred_officer3_address; ''; end
def pred_officer3_city; ''; end
def pred_officer3_state; ''; end
def pred_officer3_zip; ''; end
def pred_officer3_dob; ''; end
def pred_officer3_date_of_appt; ''; end
def AK_pred_unemp_acct_number; ''; end
def AK_succ_unemp_acct_number; ''; end
def AK_pred_wh_acct_number; ''; end
def AK_address1; ''; end
def AK_city; ''; end
def AK_zip; ''; end
def AK_number_emp_transferred; ''; end
def AK_number_emp_retained; ''; end
def AK_est_mo_wages; ''; end
def AK_est_state_wh_tax; ''; end
def AL_pred_unemp_acct_number; ''; end
def AL_succ_unemp_acct_number; ''; end
def AL_pred_wh_acct_number; ''; end
def AL_address1; ''; end
def AL_city; ''; end
def AL_zip; ''; end
def AL_number_emp_transferred; ''; end
def AL_number_emp_retained; ''; end
def AL_est_mo_wages; ''; end
def AL_est_state_wh_tax; ''; end
def AR_pred_unemp_acct_number; ''; end
def AR_succ_unemp_acct_number; ''; end
def AR_pred_wh_acct_number; ''; end
def AR_address1; ''; end
def AR_city; ''; end
def AR_zip; ''; end
def AR_number_emp_transferred; ''; end
def AR_number_emp_retained; ''; end
def AR_est_mo_wages; ''; end
def AR_est_state_wh_tax; ''; end
def AZ_pred_unemp_acct_number; ''; end
def AZ_succ_unemp_acct_number; ''; end
def AZ_pred_wh_acct_number; ''; end
def AZ_address1; ''; end
def AZ_city; ''; end
def AZ_zip; ''; end
def AZ_number_emp_transferred; ''; end
def AZ_number_emp_retained; ''; end
def AZ_est_mo_wages; ''; end
def AZ_est_state_wh_tax; ''; end
def CA_pred_unemp_acct_number; ''; end
def CA_succ_unemp_acct_number; ''; end
def CA_pred_wh_acct_number; ''; end
def CA_address1; ''; end
def CA_city; ''; end
def CA_zip; ''; end
def CA_number_emp_transferred; ''; end
def CA_number_emp_retained; ''; end
def CA_est_mo_wages; ''; end
def CA_est_state_wh_tax; ''; end
def CO_pred_unemp_acct_number; ''; end
def CO_succ_unemp_acct_number; ''; end
def CO_pred_wh_acct_number; ''; end
def CO_address1; ''; end
def CO_city; ''; end
def CO_zip; ''; end
def CO_number_emp_transferred; ''; end
def CO_number_emp_retained; ''; end
def CO_est_mo_wages; ''; end
def CO_est_state_wh_tax; ''; end
def CT_pred_unemp_acct_number; ''; end
def CT_succ_unemp_acct_number; ''; end
def CT_pred_wh_acct_number; ''; end
def CT_address1; ''; end
def CT_city; ''; end
def CT_zip; ''; end
def CT_number_emp_transferred; ''; end
def CT_number_emp_retained; ''; end
def CT_est_mo_wages; ''; end
def CT_est_state_wh_tax; ''; end
def DC_pred_unemp_acct_number; ''; end
def DC_succ_unemp_acct_number; ''; end
def DC_pred_wh_acct_number; ''; end
def DC_address1; ''; end
def DC_city; ''; end
def DC_zip; ''; end
def DC_number_emp_transferred; ''; end
def DC_number_emp_retained; ''; end
def DC_est_mo_wages; ''; end
def DC_est_state_wh_tax; ''; end
def DE_pred_unemp_acct_number; ''; end
def DE_succ_unemp_acct_number; ''; end
def DE_pred_wh_acct_number; ''; end
def DE_address1; ''; end
def DE_city; ''; end
def DE_zip; ''; end
def DE_number_emp_transferred; ''; end
def DE_number_emp_retained; ''; end
def DE_est_mo_wages; ''; end
def DE_est_state_wh_tax; ''; end
def FL_pred_unemp_acct_number; ''; end
def FL_succ_unemp_acct_number; ''; end
def FL_pred_wh_acct_number; ''; end
def FL_address1; ''; end
def FL_city; ''; end
def FL_zip; ''; end
def FL_number_emp_transferred; ''; end
def FL_number_emp_retained; ''; end
def FL_est_mo_wages; ''; end
def FL_est_state_wh_tax; ''; end
def GA_pred_unemp_acct_number; ''; end
def GA_succ_unemp_acct_number; ''; end
def GA_pred_wh_acct_number; ''; end
def GA_address1; ''; end
def GA_city; ''; end
def GA_zip; ''; end
def GA_number_emp_transferred; ''; end
def GA_number_emp_retained; ''; end
def GA_est_mo_wages; ''; end
def GA_est_state_wh_tax; ''; end
def HI_pred_unemp_acct_number; ''; end
def HI_succ_unemp_acct_number; ''; end
def HI_pred_wh_acct_number; ''; end
def HI_address1; ''; end
def HI_city; ''; end
def HI_zip; ''; end
def HI_number_emp_transferred; ''; end
def HI_number_emp_retained; ''; end
def HI_est_mo_wages; ''; end
def HI_est_state_wh_tax; ''; end
def IA_pred_unemp_acct_number; ''; end
def IA_succ_unemp_acct_number; ''; end
def IA_pred_wh_acct_number; ''; end
def IA_address1; ''; end
def IA_city; ''; end
def IA_zip; ''; end
def IA_number_emp_transferred; ''; end
def IA_number_emp_retained; ''; end
def IA_est_mo_wages; ''; end
def IA_est_state_wh_tax; ''; end
def ID_pred_unemp_acct_number; ''; end
def ID_succ_unemp_acct_number; ''; end
def ID_pred_wh_acct_number; ''; end
def ID_address1; ''; end
def ID_city; ''; end
def ID_zip; ''; end
def ID_number_emp_transferred; ''; end
def ID_number_emp_retained; ''; end
def ID_est_mo_wages; ''; end
def ID_est_state_wh_tax; ''; end
def IL_pred_unemp_acct_number; ''; end
def IL_succ_unemp_acct_number; ''; end
def IL_pred_wh_acct_number; ''; end
def IL_address1; ''; end
def IL_city; ''; end
def IL_zip; ''; end
def IL_number_emp_transferred; ''; end
def IL_number_emp_retained; ''; end
def IL_est_mo_wages; ''; end
def IL_est_state_wh_tax; ''; end
def IN_pred_unemp_acct_number; ''; end
def IN_succ_unemp_acct_number; ''; end
def IN_pred_wh_acct_number; ''; end
def IN_address1; ''; end
def IN_city; ''; end
def IN_zip; ''; end
def IN_number_emp_transferred; ''; end
def IN_number_emp_retained; ''; end
def IN_est_mo_wages; ''; end
def IN_est_state_wh_tax; ''; end
def KS_pred_unemp_acct_number; ''; end
def KS_succ_unemp_acct_number; ''; end
def KS_pred_wh_acct_number; ''; end
def KS_address1; ''; end
def KS_city; ''; end
def KS_zip; ''; end
def KS_number_emp_transferred; ''; end
def KS_number_emp_retained; ''; end
def KS_est_mo_wages; ''; end
def KS_est_state_wh_tax; ''; end
def KY_pred_unemp_acct_number; ''; end
def KY_succ_unemp_acct_number; ''; end
def KY_pred_wh_acct_number; ''; end
def KY_address1; ''; end
def KY_city; ''; end
def KY_zip; ''; end
def KY_number_emp_transferred; ''; end
def KY_number_emp_retained; ''; end
def KY_est_mo_wages; ''; end
def KY_est_state_wh_tax; ''; end
def LA_pred_unemp_acct_number; ''; end
def LA_succ_unemp_acct_number; ''; end
def LA_pred_wh_acct_number; ''; end
def LA_address1; ''; end
def LA_city; ''; end
def LA_zip; ''; end
def LA_number_emp_transferred; ''; end
def LA_number_emp_retained; ''; end
def LA_est_mo_wages; ''; end
def LA_est_state_wh_tax; ''; end
def MA_pred_unemp_acct_number; ''; end
def MA_succ_unemp_acct_number; ''; end
def MA_pred_wh_acct_number; ''; end
def MA_address1; ''; end
def MA_city; ''; end
def MA_zip; ''; end
def MA_number_emp_transferred; ''; end
def MA_number_emp_retained; ''; end
def MA_est_mo_wages; ''; end
def MA_est_state_wh_tax; ''; end
def MD_pred_unemp_acct_number; ''; end
def MD_succ_unemp_acct_number; ''; end
def MD_pred_wh_acct_number; ''; end
def MD_address1; ''; end
def MD_city; ''; end
def MD_zip; ''; end
def MD_number_emp_transferred; ''; end
def MD_number_emp_retained; ''; end
def MD_est_mo_wages; ''; end
def MD_est_state_wh_tax; ''; end
def ME_pred_unemp_acct_number; ''; end
def ME_succ_unemp_acct_number; ''; end
def ME_pred_wh_acct_number; ''; end
def ME_address1; ''; end
def ME_city; ''; end
def ME_zip; ''; end
def ME_number_emp_transferred; ''; end
def ME_number_emp_retained; ''; end
def ME_est_mo_wages; ''; end
def ME_est_state_wh_tax; ''; end
def MI_pred_unemp_acct_number; ''; end
def MI_succ_unemp_acct_number; ''; end
def MI_pred_wh_acct_number; ''; end
def MI_address1; ''; end
def MI_city; ''; end
def MI_zip; ''; end
def MI_number_emp_transferred; ''; end
def MI_number_emp_retained; ''; end
def MI_est_mo_wages; ''; end
def MI_est_state_wh_tax; ''; end
def MN_pred_unemp_acct_number; ''; end
def MN_succ_unemp_acct_number; ''; end
def MN_pred_wh_acct_number; ''; end
def MN_address1; ''; end
def MN_city; ''; end
def MN_zip; ''; end
def MN_number_emp_transferred; ''; end
def MN_number_emp_retained; ''; end
def MN_est_mo_wages; ''; end
def MN_est_state_wh_tax; ''; end
def MO_pred_unemp_acct_number; ''; end
def MO_succ_unemp_acct_number; ''; end
def MO_pred_wh_acct_number; ''; end
def MO_address1; ''; end
def MO_city; ''; end
def MO_zip; ''; end
def MO_number_emp_transferred; ''; end
def MO_number_emp_retained; ''; end
def MO_est_mo_wages; ''; end
def MO_est_state_wh_tax; ''; end
def MS_pred_unemp_acct_number; ''; end
def MS_succ_unemp_acct_number; ''; end
def MS_pred_wh_acct_number; ''; end
def MS_address1; ''; end
def MS_city; ''; end
def MS_zip; ''; end
def MS_number_emp_transferred; ''; end
def MS_number_emp_retained; ''; end
def MS_est_mo_wages; ''; end
def MS_est_state_wh_tax; ''; end
def MT_pred_unemp_acct_number; ''; end
def MT_succ_unemp_acct_number; ''; end
def MT_pred_wh_acct_number; ''; end
def MT_address1; ''; end
def MT_city; ''; end
def MT_zip; ''; end
def MT_number_emp_transferred; ''; end
def MT_number_emp_retained; ''; end
def MT_est_mo_wages; ''; end
def MT_est_state_wh_tax; ''; end
def NC_pred_unemp_acct_number; ''; end
def NC_succ_unemp_acct_number; ''; end
def NC_pred_wh_acct_number; ''; end
def NC_address1; ''; end
def NC_city; ''; end
def NC_zip; ''; end
def NC_number_emp_transferred; ''; end
def NC_number_emp_retained; ''; end
def NC_est_mo_wages; ''; end
def NC_est_state_wh_tax; ''; end
def ND_pred_unemp_acct_number; ''; end
def ND_succ_unemp_acct_number; ''; end
def ND_pred_wh_acct_number; ''; end
def ND_address1; ''; end
def ND_city; ''; end
def ND_zip; ''; end
def ND_number_emp_transferred; ''; end
def ND_number_emp_retained; ''; end
def ND_est_mo_wages; ''; end
def ND_est_state_wh_tax; ''; end
def NE_pred_unemp_acct_number; ''; end
def NE_succ_unemp_acct_number; ''; end
def NE_pred_wh_acct_number; ''; end
def NE_address1; ''; end
def NE_city; ''; end
def NE_zip; ''; end
def NE_number_emp_transferred; ''; end
def NE_number_emp_retained; ''; end
def NE_est_mo_wages; ''; end
def NE_est_state_wh_tax; ''; end
def NH_pred_unemp_acct_number; ''; end
def NH_succ_unemp_acct_number; ''; end
def NH_pred_wh_acct_number; ''; end
def NH_address1; ''; end
def NH_city; ''; end
def NH_zip; ''; end
def NH_number_emp_transferred; ''; end
def NH_number_emp_retained; ''; end
def NH_est_mo_wages; ''; end
def NH_est_state_wh_tax; ''; end
def NJ_pred_unemp_acct_number; ''; end
def NJ_succ_unemp_acct_number; ''; end
def NJ_pred_wh_acct_number; ''; end
def NJ_address1; ''; end
def NJ_city; ''; end
def NJ_zip; ''; end
def NJ_number_emp_transferred; ''; end
def NJ_number_emp_retained; ''; end
def NJ_est_mo_wages; ''; end
def NJ_est_state_wh_tax; ''; end
def NM_pred_unemp_acct_number; ''; end
def NM_succ_unemp_acct_number; ''; end
def NM_pred_wh_acct_number; ''; end
def NM_address1; ''; end
def NM_city; ''; end
def NM_zip; ''; end
def NM_number_emp_transferred; ''; end
def NM_number_emp_retained; ''; end
def NM_est_mo_wages; ''; end
def NM_est_state_wh_tax; ''; end
def NV_pred_unemp_acct_number; ''; end
def NV_succ_unemp_acct_number; ''; end
def NV_pred_wh_acct_number; ''; end
def NV_address1; ''; end
def NV_city; ''; end
def NV_zip; ''; end
def NV_number_emp_transferred; ''; end
def NV_number_emp_retained; ''; end
def NV_est_mo_wages; ''; end
def NV_est_state_wh_tax; ''; end
def NY_pred_unemp_acct_number; ''; end
def NY_succ_unemp_acct_number; ''; end
def NY_pred_wh_acct_number; ''; end
def NY_address1; ''; end
def NY_city; ''; end
def NY_zip; ''; end
def NY_number_emp_transferred; ''; end
def NY_number_emp_retained; ''; end
def NY_est_mo_wages; ''; end
def NY_est_state_wh_tax; ''; end
def OH_pred_unemp_acct_number; ''; end
def OH_succ_unemp_acct_number; ''; end
def OH_pred_wh_acct_number; ''; end
def OH_address1; ''; end
def OH_city; ''; end
def OH_zip; ''; end
def OH_number_emp_transferred; ''; end
def OH_number_emp_retained; ''; end
def OH_est_mo_wages; ''; end
def OH_est_state_wh_tax; ''; end
def OK_pred_unemp_acct_number; ''; end
def OK_succ_unemp_acct_number; ''; end
def OK_pred_wh_acct_number; ''; end
def OK_address1; ''; end
def OK_city; ''; end
def OK_zip; ''; end
def OK_number_emp_transferred; ''; end
def OK_number_emp_retained; ''; end
def OK_est_mo_wages; ''; end
def OK_est_state_wh_tax; ''; end
def OR_pred_unemp_acct_number; ''; end
def OR_succ_unemp_acct_number; ''; end
def OR_pred_wh_acct_number; ''; end
def OR_address1; ''; end
def OR_city; ''; end
def OR_zip; ''; end
def OR_number_emp_transferred; ''; end
def OR_number_emp_retained; ''; end
def OR_est_mo_wages; ''; end
def OR_est_state_wh_tax; ''; end
def PA_pred_unemp_acct_number; ''; end
def PA_succ_unemp_acct_number; ''; end
def PA_pred_wh_acct_number; ''; end
def PA_address1; ''; end
def PA_city; ''; end
def PA_zip; ''; end
def PA_number_emp_transferred; ''; end
def PA_number_emp_retained; ''; end
def PA_est_mo_wages; ''; end
def PA_est_state_wh_tax; ''; end
def PR_pred_unemp_acct_number; ''; end
def PR_succ_unemp_acct_number; ''; end
def PR_pred_wh_acct_number; ''; end
def PR_address1; ''; end
def PR_city; ''; end
def PR_zip; ''; end
def PR_number_emp_transferred; ''; end
def PR_number_emp_retained; ''; end
def PR_est_mo_wages; ''; end
def PR_est_state_wh_tax; ''; end
def RI_pred_unemp_acct_number; ''; end
def RI_succ_unemp_acct_number; ''; end
def RI_pred_wh_acct_number; ''; end
def RI_address1; ''; end
def RI_city; ''; end
def RI_zip; ''; end
def RI_number_emp_transferred; ''; end
def RI_number_emp_retained; ''; end
def RI_est_mo_wages; ''; end
def RI_est_state_wh_tax; ''; end
def SC_pred_unemp_acct_number; ''; end
def SC_succ_unemp_acct_number; ''; end
def SC_pred_wh_acct_number; ''; end
def SC_address1; ''; end
def SC_city; ''; end
def SC_zip; ''; end
def SC_number_emp_transferred; ''; end
def SC_number_emp_retained; ''; end
def SC_est_mo_wages; ''; end
def SC_est_state_wh_tax; ''; end
def SD_pred_unemp_acct_number; ''; end
def SD_succ_unemp_acct_number; ''; end
def SD_pred_wh_acct_number; ''; end
def SD_address1; ''; end
def SD_city; ''; end
def SD_zip; ''; end
def SD_number_emp_transferred; ''; end
def SD_number_emp_retained; ''; end
def SD_est_mo_wages; ''; end
def SD_est_state_wh_tax; ''; end
def TN_pred_unemp_acct_number; ''; end
def TN_succ_unemp_acct_number; ''; end
def TN_pred_wh_acct_number; ''; end
def TN_address1; ''; end
def TN_city; ''; end
def TN_zip; ''; end
def TN_number_emp_transferred; ''; end
def TN_number_emp_retained; ''; end
def TN_est_mo_wages; ''; end
def TN_est_state_wh_tax; ''; end
def TX_pred_unemp_acct_number; ''; end
def TX_succ_unemp_acct_number; ''; end
def TX_pred_wh_acct_number; ''; end
def TX_address1; ''; end
def TX_city; ''; end
def TX_zip; ''; end
def TX_number_emp_transferred; ''; end
def TX_number_emp_retained; ''; end
def TX_est_mo_wages; ''; end
def TX_est_state_wh_tax; ''; end
def UT_pred_unemp_acct_number; ''; end
def UT_succ_unemp_acct_number; ''; end
def UT_pred_wh_acct_number; ''; end
def UT_address1; ''; end
def UT_city; ''; end
def UT_zip; ''; end
def UT_number_emp_transferred; ''; end
def UT_number_emp_retained; ''; end
def UT_est_mo_wages; ''; end
def UT_est_state_wh_tax; ''; end
def VA_pred_unemp_acct_number; ''; end
def VA_succ_unemp_acct_number; ''; end
def VA_pred_wh_acct_number; ''; end
def VA_address1; ''; end
def VA_city; ''; end
def VA_zip; ''; end
def VA_number_emp_transferred; ''; end
def VA_number_emp_retained; ''; end
def VA_est_mo_wages; ''; end
def VA_est_state_wh_tax; ''; end
def VI_pred_unemp_acct_number; ''; end
def VI_succ_unemp_acct_number; ''; end
def VI_pred_wh_acct_number; ''; end
def VI_address1; ''; end
def VI_city; ''; end
def VI_zip; ''; end
def VI_number_emp_transferred; ''; end
def VI_number_emp_retained; ''; end
def VI_est_mo_wages; ''; end
def VI_est_state_wh_tax; ''; end
def VT_pred_unemp_acct_number; ''; end
def VT_succ_unemp_acct_number; ''; end
def VT_pred_wh_acct_number; ''; end
def VT_address1; ''; end
def VT_city; ''; end
def VT_zip; ''; end
def VT_number_emp_transferred; ''; end
def VT_number_emp_retained; ''; end
def VT_est_mo_wages; ''; end
def VT_est_state_wh_tax; ''; end
def WA_pred_unemp_acct_number; ''; end
def WA_succ_unemp_acct_number; ''; end
def WA_pred_wh_acct_number; ''; end
def WA_address1; ''; end
def WA_city; ''; end
def WA_zip; ''; end
def WA_number_emp_transferred; ''; end
def WA_number_emp_retained; ''; end
def WA_est_mo_wages; ''; end
def WA_est_state_wh_tax; ''; end
def WI_pred_unemp_acct_number; ''; end
def WI_succ_unemp_acct_number; ''; end
def WI_pred_wh_acct_number; ''; end
def WI_address1; ''; end
def WI_city; ''; end
def WI_zip; ''; end
def WI_number_emp_transferred; ''; end
def WI_number_emp_retained; ''; end
def WI_est_mo_wages; ''; end
def WI_est_state_wh_tax; ''; end
def WV_pred_unemp_acct_number; ''; end
def WV_succ_unemp_acct_number; ''; end
def WV_pred_wh_acct_number; ''; end
def WV_address1; ''; end
def WV_city; ''; end
def WV_zip; ''; end
def WV_number_emp_transferred; ''; end
def WV_number_emp_retained; ''; end
def WV_est_mo_wages; ''; end
def WV_est_state_wh_tax; ''; end
def WY_pred_unemp_acct_number; ''; end
def WY_succ_unemp_acct_number; ''; end
def WY_pred_wh_acct_number; ''; end
def WY_address1; ''; end
def WY_city; ''; end
def WY_zip; ''; end
def WY_number_emp_transferred; ''; end
def WY_number_emp_retained; ''; end
def WY_est_mo_wages; ''; end
def WY_est_state_wh_tax; ''; end
end

class Fcc
 def applicant_middle_initial; ''; end
 def applicant_suffix; ''; end
 def applicant_address; ''; end
 def applicant_po_box; ''; end
 def applicant_city; ''; end
 def applicant_state; ''; end
 def applicant_zip; ''; end
 def applicant_country; ''; end
 def applicant_frn; ''; end
 def applicant_phone; ''; end
 def applicant_fax; ''; end
 def applicant_email; ''; end
 def contact_first_name; ''; end
 def contact_middle_initial; ''; end
 def contact_last_name; ''; end
 def contact_suffix; ''; end
 def contact_entity_name; ''; end
 def contact_address; ''; end
 def contact_po_box; ''; end
 def contact_city; ''; end
 def contact_state; ''; end
 def contact_zip; ''; end
 def contact_phone; ''; end
 def contact_fax; ''; end
 def contact_email; ''; end
 def signatory_first_name; ''; end
 def signatory_middle_initial; ''; end
 def signatory_last_name; ''; end
 def signatory_suffix; ''; end
 def signatory_title; ''; end
 def applicant_first_name; ''; end
 def applicant_last_name; ''; end
 def applicant_entity_name; ''; end
end

# ***** Field Data *****
box2_1 = ''
box2_2 = ''
box2_3 = ''
box2_4 = ''
box2_5 = ''
box2_6 = ''
box2_7 = ''
box2_8 = ''
box2_9 = ''
box2_10 = ''
box2_11 = ''
box2_12 = ''
box2_13 = ''
box2_14 = ''
box2_15 = ''
box2_16 = ''
box2_17 = ''
box2_18 = ''
box2_19 = ''
box2_20 = ''
box2_21 = ''
box2_22 = ''
box2_23 = ''
box2_24 = ''
box2_25 = ''
box2_26 = ''
box2_27 = ''
box2_28 = ''
box2_29 = ''
box2_30 = ''
box2_31 = ''
box2_32 = ''
box2_33 = ''
box2_34 = ''
box2_35 = ''
box2_36 = ''
box2_37 = ''
box2_38 = ''
box2_39 = ''
box2_40 = ''
box2_41 = ''
box2_42 = ''
box2_43 = ''
box2_44 = ''
box2_45 = ''
box2_46 = ''
box2_47 = ''
box2_48 = ''
box2_49 = ''
box2_50 = ''
box2_51 = ''
box2_52 = ''
box2_53 = ''
box2_54 = ''
box2_55 = ''
box2_56 = ''
box2_57 = ''
box2_58 = ''
box2_59 = '6459'
box3_1 = ''
box3_2 = ''
box3_3 = ''
box3_4 = ''
box3_5 = ''
box3_6 = ''
box3_7 = ''
box3_8 = ''
box3_9 = ''
box3_10 = ''
box3_11 = ''
box3_12 = ''
box3_13 = ''
box3_14 = ''
box3_15 = ''
box3_16 = ''
box3_17 = ''
box3_18 = ''
box3_19 = ''
box3_20 = ''
box3_21 = ''
box3_22 = ''
box3_23 = ''
box3_24 = ''
box3_25 = ''
box3_26 = ''
box3_27 = ''
box3_28 = ''
box3_29 = ''
box3_30 = ''
box3_31 = '6460'
box4_1 = ''
box4_2 = ''
box4_3 = ''
box4_4 = ''
box4_5 = ''
box4_6 = ''
box4_7 = ''
box4_8 = ''
box4_9 = ''
box4_10 = ''
box4_11 = ''
box4_12 = ''
box4_13 = ''
box4_14 = ''
box4_17 = ''
box4_18 = ''
box4_19 = ''
box4_20 = ''
box4_21 = ''
box4_22 = ''
box4_23 = ''
box4_24 = ''
box4_25 = ''
box4_26 = ''
box4_27 = ''
box4_28 = ''
box4_31 = ''
box4_32 = ''
box4_33 = ''
box4_34 = ''
box4_35 = ''
box4_36 = ''
box4_29 = ''
box4_30 = '6461'
box5_1 = ''
box5_2 = ''
box5_3 = ''
box5_4 = ''
box5_5 = ''
box5_6 = ''
box5_27 = ''
box5_7 = ''
box5_8 = ''
box5_9 = ''
box5_10 = ''
box5_11 = ''
box5_12 = ''
box5_13 = ''
box5_14 = ''
box5_15 = ''
box5_16 = ''
box5_17 = ''
box5_18 = ''
box5_19 = ''
box5_20 = ''
box5_21 = ''
box5_22 = ''
box5_23 = ''
box5_24 = ''
box5_25 = '6462'
box5_26 = ''
box6_1 = ''
box6_2 = ''
box6_3 = ''
box6_4 = ''
box6_28 = ''
box6_5 = ''
box6_6 = ''
box6_7 = ''
box6_8 = ''
box6_9 = ''
box6_10 = ''
box6_11 = ''
box6_12 = ''
box6_13 = ''
box6_14 = ''
box6_15 = ''
box6_16 = ''
box6_17 = ''
box6_18 = ''
box6_19 = ''
box6_20 = ''
box6_23 = ''
box6_24 = ''
box6_25 = ''
box6_26 = ''
box6_27 = ''
box6_21 = ''
box6_22 = '6463'
box7_1 = ''
box7_2 = ''
box7_3 = ''
box7_4 = ''
box7_5 = ''
box7_6 = ''
box7_7 = ''
box7_8 = ''
box7_9 = ''
box7_10 = ''
box7_11 = ''
box7_12 = ''
box7_13 = ''
box7_14 = ''
box7_15 = ''
box7_16 = ''
box7_17 = ''
box7_18 = ''
box7_19 = ''
box7_20 = ''
box7_21 = ''
box7_22 = ''
box7_23 = ''
box7_24 = ''
box7_25 = ''
box7_26 = ''
box7_27 = ''
box7_28 = ''
box7_29 = ''
box7_30 = ''
box7_31 = ''
box7_32 = ''
box7_33 = ''
box7_34 = ''
box7_35 = ''
box7_36 = ''
box7_37 = ''
box7_38 = ''
box7_39 = ''
box7_40 = ''
box7_41 = ''
box7_42 = ''
box7_43 = ''
box7_44 = ''
box7_45 = ''
box7_46 = ''
box7_47 = ''
box7_48 = '6464'
box8_1 = ''
box8_2 = ''
box8_3 = ''
box8_4 = ''
box8_5 = ''
box8_6 = ''
box8_7 = ''
box8_8 = ''
box8_9 = ''
box8_10 = ''
box8_11 = ''
box8_12 = ''
box8_13 = ''
box8_14 = ''
box8_15 = ''
box8_16 = ''
box8_17 = ''
box8_18 = ''
box8_19 = ''
box8_20 = ''
box8_21 = ''
box8_22 = ''
box8_23 = ''
box8_24 = ''
box8_25 = ''
box8_26 = ''
box8_27 = ''
box8_28 = ''
box8_29 = ''
box8_30 = ''
box8_31 = ''
box8_32 = ''
box8_33 = ''
box8_34 = ''
box8_35 = ''
box8_36 = ''
box8_37 = ''
box8_38 = ''
box8_39 = ''
box8_40 = ''
box8_41 = ''
box8_42 = '6465'
box9_1 = ''
box9_2 = ''
box9_3 = ''
box9_4 = ''
box9_5 = ''
box9_6 = ''
box9_7 = ''
box9_8 = ''
box9_9 = ''
box9_10 = ''
box9_11 = ''
box9_12 = ''
box9_13 = ''
box9_14 = ''
box9_15 = ''
box9_16 = ''
box9_17 = ''
box9_18 = ''
box9_19 = ''
box9_20 = ''
box9_21 = ''
box9_22 = ''
box9_23 = ''
box9_24 = ''
box9_25 = ''
box9_26 = ''
box9_27 = ''
box9_28 = ''
box9_29 = ''
box9_30 = ''
box9_31 = ''
box9_32 = ''
box9_33 = ''
box9_34 = ''
box9_35 = ''
box9_36 = ''
box9_37 = ''
box9_38 = ''
box9_39 = ''
box9_40 = ''
box9_41 = ''
box9_42 = '6466'

# ***** Calculations *****

$,="\x02"
$\="\x03\n"

individual = Individual.new
preparer = Preparer.new


tmp = individual.first_name.strip[0,16]
print 'box2_6', tmp if !tmp.empty?

tmp = individual.middle_initial.strip[0,1]
print 'box2_7', tmp if !tmp.empty?

tmp = individual.last_name.strip[0,20]
print 'box2_8', tmp if !tmp.empty?

tmp = individual.suffix.strip[0,3]
print 'box2_9', tmp if !tmp.empty?

tmp = individual.ssn.delete("^0-9")
print 'box2_10', tmp if !tmp.empty?

#
# Per 2D: "Provide only if the return is a joint return." Instructions also say this..."On a joint return, your names
# and Social Security Numbers must be listed....."
#
if (!individual.married_joint.strip.empty?)

	tmp = individual.spouse_first_name.strip[0,16]
	print 'box2_11', tmp if !tmp.empty?
	
	tmp = individual.spouse_middle_initial.strip[0,1]
	print 'box2_12', tmp if !tmp.empty?
	
	tmp = individual.spouse_last_name.strip[0,20]
	print 'box2_13', tmp if !tmp.empty?
	
	tmp = individual.spouse_suffix.strip[0,3]
	print 'box2_14', tmp if !tmp.empty?
end

#Note 11/11/10:Per instructions:"If married, print Social Security Numbers for both you and your spouse." So flow spouse for both
#married and separate. [11/17/11: Also indicated in the 2D]

if (!individual.married_joint.strip.empty?) or (!individual.married_separate.strip.empty?)

	tmp = individual.spouse_ssn.delete("^0-9")
	print 'box2_15', tmp if !tmp.empty?
end

#Note 11/12/10:Per the specs. if there is no address entered the address box should default to "General Delivery. So we need to use
#a unique variable for the address and then will check the variable in the calc. code just below the dataflow to see if we need to
#plug in the default.
primary_address = (individual.address + ' ' + (individual.apartment_number.strip.empty? ? '' : 'Apt. #' + individual.apartment_number)).squeeze(' ').strip[0,35]
print 'box2_16', primary_address if !primary_address.empty?

tmp = individual.city.strip[0,25]
print 'box2_17', tmp if !tmp.empty?

tmp = individual.state.strip[0,2]
print 'box2_18', tmp if !tmp.empty?

#
# 5 or hyphenated 9 digit Zip Code Validation for one box: [defaults to .strip]:
#
tmp = (individual.zip.delete(" -") =~ /^(\d{5})(\d{4})?$/ ? "#{$1}#{($2 ? '-'+$2 : '')}" : individual.zip.strip)
print 'box2_19', tmp if !tmp.empty?

tmp = if( !individual.single.strip.empty? ) then '1'
	elsif( !individual.married_joint.strip.empty? ) then '2'
	elsif( !individual.married_separate.strip.empty? ) then '3'
	elsif( !individual.head_of_household.strip.empty? ) then '4'
	elsif( !individual.widow_widower.strip.empty? ) then '5'
	else ''
	end
print 'box2_23', tmp if !tmp.empty?

#Note 11/11/10:Last year the qualifying widower box was added to the exemptions. The instructions aren't real clear as to it
#being Ok claim this exemption based on filing status. It says to list the same exemptions as on your Federal unless you are a
#dependent on another return, 65 or over, blind, or your filing status is Qualifying Widow. This is the same thing it said last 
#year, and with the exception we can't check the qualifying widow box based on the filing status.

print 'box2_25', 'X' if !individual.sixty_five_plus.strip.empty?
print 'box2_26', 'X' if !individual.blind.strip.empty?
#This form has been flowing spouse exemption info regardless of filing status for years with no issues.
print 'box2_29', 'X' if !individual.spouse_65_plus.strip.empty?
print 'box2_30', 'X' if !individual.spouse_blind.strip.empty?

#
# 10 digit Phone number: 9999999999 - defaults to .strip:
#
tmp = (case
		when (!individual.work_phone.strip.empty?): individual.work_phone
		when (!individual.phone.strip.empty?): individual.phone
		else individual.mobile_phone
	end).strip
tmp = $1 if (tmp.delete("^0-9") =~ /^(\d{10})$/)
print 'box2_20', tmp if !tmp.empty?

#
# This variable is used when the form wants a four digit year for the dependent DOB. The profile validates the DOB
# fields as "MM/DD/YY" so we need to use 'yy' to determine the two digit century value. If the profile's YY is greater
# than the current YY [at the time this code runs as we are using Time.now] then the first two YYs of the 4 digit year
# must be 19, else it must be 20. The only problem would be a dependent that was born in 1903, or some other
# highly-non-probable date.
#
# This will handle a 4 digit year if the profile validation is changed to a 4 digit year.
#
# Display Dependent DOB as "MM/DD/YYYY" - default to .strip:
#
yy = Time.now.strftime("%y").to_i

tmp = (individual.dependent1_first_name + ' ' + individual.dependent1_last_name).squeeze(' ').strip
print 'box2_33', tmp if !tmp.empty?

tmp = individual.dependent1_ssn.delete("^0-9")
print 'box2_34', tmp if !tmp.empty?

tmp = individual.dependent1_relationship.strip
print 'box2_35', tmp if !tmp.empty?

tmp = (individual.dependent1_dob.delete("^0-9") =~ /^(\d\d)(\d\d)(\d\d)?(\d\d)$/ ? "#{$1}/#{$2}/#{$3 ? $3 : $4.to_i > yy ? 19 : 20}#{$4}" : individual.dependent1_dob.strip)
print 'box2_36', tmp if !tmp.empty?

tmp = (individual.dependent2_first_name + ' ' + individual.dependent2_last_name).squeeze(' ').strip
print 'box2_37', tmp if !tmp.empty?

tmp = individual.dependent2_ssn.delete("^0-9")
print 'box2_38', tmp if !tmp.empty?

tmp = individual.dependent2_relationship.strip
print 'box2_39', tmp if !tmp.empty?

tmp = (individual.dependent2_dob.delete("^0-9") =~ /^(\d\d)(\d\d)(\d\d)?(\d\d)$/ ? "#{$1}/#{$2}/#{$3 ? $3 : $4.to_i > yy ? 19 : 20}#{$4}" : individual.dependent2_dob.strip)
print 'box2_40', tmp if !tmp.empty?

tmp = (individual.dependent3_first_name + ' ' + individual.dependent3_last_name).squeeze(' ').strip
print 'box2_41', tmp if !tmp.empty?

tmp = individual.dependent3_ssn.delete("^0-9")
print 'box2_42', tmp if !tmp.empty?

tmp = individual.dependent3_relationship.strip
print 'box2_43', tmp if !tmp.empty?

tmp = (individual.dependent3_dob.delete("^0-9") =~ /^(\d\d)(\d\d)(\d\d)?(\d\d)$/ ? "#{$1}/#{$2}/#{$3 ? $3 : $4.to_i > yy ? 19 : 20}#{$4}" : individual.dependent3_dob.strip)
print 'box2_44', tmp if !tmp.empty?

tmp = (individual.dependent4_first_name + ' ' + individual.dependent4_last_name).squeeze(' ').strip
print 'box2_45', tmp if !tmp.empty?

tmp = individual.dependent4_ssn.delete("^0-9")
print 'box2_46', tmp if !tmp.empty?

tmp = individual.dependent4_relationship.strip
print 'box2_47', tmp if !tmp.empty?

tmp = (individual.dependent4_dob.delete("^0-9") =~ /^(\d\d)(\d\d)(\d\d)?(\d\d)$/ ? "#{$1}/#{$2}/#{$3 ? $3 : $4.to_i > yy ? 19 : 20}#{$4}" : individual.dependent4_dob.strip)
print 'box2_48', tmp if !tmp.empty?

tmp = (individual.dependent5_first_name + ' ' + individual.dependent5_last_name).squeeze(' ').strip
print 'box2_49', tmp if !tmp.empty?

tmp = individual.dependent5_ssn.delete("^0-9")
print 'box2_50', tmp if !tmp.empty?

tmp = individual.dependent5_relationship.strip
print 'box2_51', tmp if !tmp.empty?

tmp = (individual.dependent5_dob.delete("^0-9") =~ /^(\d\d)(\d\d)(\d\d)?(\d\d)$/ ? "#{$1}/#{$2}/#{$3 ? $3 : $4.to_i > yy ? 19 : 20}#{$4}" : individual.dependent5_dob.strip)
print 'box2_52', tmp if !tmp.empty?

tmp = (individual.dependent6_first_name + ' ' + individual.dependent6_last_name).squeeze(' ').strip
print 'box2_53', tmp if !tmp.empty?

tmp = individual.dependent6_ssn.delete("^0-9")
print 'box2_54', tmp if !tmp.empty?

tmp = individual.dependent6_relationship.strip
print 'box2_55', tmp if !tmp.empty?

tmp = (individual.dependent6_dob.delete("^0-9") =~ /^(\d\d)(\d\d)(\d\d)?(\d\d)$/ ? "#{$1}/#{$2}/#{$3 ? $3 : $4.to_i > yy ? 19 : 20}#{$4}" : individual.dependent6_dob.strip)
print 'box2_56', tmp if !tmp.empty?

tmp = (case
		when (!preparer.work_phone.strip.empty?): preparer.work_phone
		when (!preparer.phone.strip.empty?): preparer.phone
		else preparer.mobile_phone
    end).delete("^0-9")
print 'box5_17', tmp if !tmp.empty?

#Validated w/no hyphens
tmp = (case
		when (!preparer.ptin.strip.empty?): preparer.ptin.strip
		when (!preparer.fein.strip.empty?): preparer.fein.delete("^0-9")
		else preparer.ssn.delete("^0-9")
	end)
print 'box5_21', tmp if !tmp.empty?

#
# End of DataFlow.
#

# Round amounts to the nearest whole dollar (enter as 100)

# Do Not leave dollar fields blank (enter 0)

#
# ########### Check Digit Method #############
#
# This function always returns a single digit integer as the check digit.
# The input and multiplier are strings.
# The modulus is an integer (usually 10 or 11).
# Set sum_digits to true if you want a sum of the product digits.
# Set rtl to true if the multiplier string should be created from right to left.
def check_digit(input, multiplier, modulus, sum_digits = false, rtl = false)
	# Correct input arguments.
	input = input.to_s
	multiplier = multiplier.to_s
	modulus = modulus.to_i
	sum_digits = false unless sum_digits.kind_of? TrueClass
	rtl = false unless rtl.kind_of? TrueClass
	
	# Create multiplier string.
	extra = input.length % multiplier.length
	if rtl
		multiplier.reverse! 
		multiplier = multiplier[-extra, extra] + (multiplier * (input.length / multiplier.length))
	else
		multiplier = (multiplier * (input.length / multiplier.length)) + multiplier[0, extra]
	end
	
	# Generate the sum.
	sum = 0
	0.upto(input.length-1) { |i|
		step = input[i, 1].to_i * multiplier[i, 1].to_i
		# Do they want sum of the products, or sum of the product digits?
		if (sum_digits)
			sum += step % 10 + step / 10
		else
			sum += step
		end
	}

	# Value to return as a single digit integer.
	((modulus - (sum % modulus)) % modulus) % 10
	
end

#Note 11/12/10:As described above in the address dataflow we need to default the address field to GENERAL DELIVERY if nothing
#is entered. So we check to see if both the address box and the variable are empty. If they are then we can plug in the default
#GENERAL DELIVERY using a replace statement.
if (box2_16.strip.empty?) and (primary_address.strip.empty?)
	box2_16.replace('GENERAL DELIVERY')
	print 'box2_16', box2_16
end

#
# 12/09/13 - In the Analyst notes it states the blanking calculated fileds should be handled the same as last year.

# 1/11/13 - page 1 of calc. attachment says  page 6-10 blank and make sure its blank in 2D, if anything is put in on page 6-10 then it will be active in 2D

#Note 11/11/10:Doing all of the schedules first as values from the schedules need to be posted back to the return.

#
#-############################################################
#
# Schedule E:
#
# if anything is used on this page then the ssn box will be active
#
# sched_E_1 needs to be blank in 2D if page isnt filled out
#
if ( (box7_2 + box7_3 + box7_4 + box7_5 + box7_7 + box7_8 + box7_9 + box7_10 + box7_11 + box7_12 + box7_13 + box7_14 + box7_15 + box7_16 + box7_17 + box7_18 + box7_19 + box7_20 + box7_21 + box7_22 + box7_23 + box7_24 + box7_25 + box7_26 + box7_27 + box7_28 + box7_29 + box7_30 + box7_32 + box7_35 + box7_37 + box7_38 + box7_39 + box7_40 + box7_41 + box7_42 + box7_43 + box7_44 + box7_45 + box7_46 + box7_47).delete(" ").empty?)

	box7_1 = ''
	box7_6 = ''
	box7_31 = ''
	box7_33 = ''
	box7_34 = ''
	box7_36 = ''
	sched_E_1 = false
	
else
	box7_1 = box2_10
# Per instructions [and specs - they say no negatives on form except for Line 1 of Sch. E] - not less than zero.	
	box7_6 = '%0.0f' % [(box7_2.strip.empty? ? box7_3.to_f : -box7_3.to_f) + box7_4.to_f + box7_5.to_f, 0.0].max
	box7_31 = '%0.0f' % (box7_9.to_f + box7_12.to_f + box7_15.to_f + box7_18.to_f + box7_21.to_f + box7_24.to_f + box7_27.to_f + box7_30.to_f)
	box7_33 = '%0.0f' % [box7_31.to_f - box7_32.to_f, 0.0].max
	box7_34 = '%0.0f' % [box7_6.to_f - box7_33.to_f, 0.0].max	
	box7_36 = '%0.0f' % [box7_34.to_f - box7_35.to_f, 0.0].max
	sched_E_1 = true
end

print 'box7_1', box7_1
print 'box7_6', box7_6
print 'box7_31', box7_31
print 'box7_33', box7_33
print 'box7_34', box7_34
print 'box7_36', box7_36
#
#-############################################################
#
# Schedule F and Schedule H
#
if ( (box8_2 + box8_3 + box8_4 + box8_5 + box8_6 + box8_7 + box8_8 + box8_9 + box8_10 + box8_11 + box8_12 + box8_13 + box8_14 + box8_15 + box8_16 + box8_17 + box8_18 + box8_19 + box8_20 + box8_21 + box8_22 + box8_23 + box8_24 + box8_25 + box8_26 + box8_27 + box8_28 + box8_29 + box8_30 + box8_31 + box8_32 + box8_33 + box8_34 + box8_35 + box8_36 + box8_37 +  box8_39 + box8_40).delete(" ").empty?)

	box8_1 = ''
	box8_38 = ''
	box8_41 = ''
else
	box8_1 = box2_10
	box8_38 = '%0.0f' % (box8_22.to_f + box8_25.to_f + box8_28.to_f + box8_31.to_f + box8_34.to_f + box8_37.to_f)
	box8_41 = '%0.0f' % (box8_39.to_f + box8_40.to_f)
end

print 'box8_1', box8_1
print 'box8_38', box8_38
print 'box8_41', box8_41

#
#-############################################################
#
# Schedule G:
#

#Note 11/11/10:We can't calc. line 2D by checking the boxes because the user may have extra dependents that they write in.

if ( (box9_2 + box9_3 + box9_4 + box9_5 + box9_6 + box9_7 + box9_8 + box9_9 + box9_10 + box9_11 + box9_12 + box9_13 + box9_14 + box9_15 + box9_16 + box9_17 + box9_19 + box9_21 + box9_23 + box9_24 + box9_25 + box9_26 + box9_27 + box9_28 + box9_29 + box9_30 + box9_31 + box9_32 + box9_33 + box9_34 + box9_35 + box9_36 + box9_37 + box9_38 + box9_39 + box9_40 ).delete(" ").empty?)

	box9_1 = ''
	box9_18 = ''
	box9_20 = ''
	box9_22 = ''
	box9_41 = ''
else
	box9_1 = box2_10
	box9_18 = '%0.0f' % (box9_17.to_f * 100.0)
	box9_20 = '%0.0f' % (box9_19.to_f * 0.4)
	box9_22 = '%0.0f' % [box9_21.to_f * 0.1, 25.0].min
	box9_41 = '%0.0f' % (box9_2.to_f + box9_18.to_f + box9_20.to_f + box9_22.to_f + box9_25.to_f + box9_28.to_f + box9_31.to_f + box9_34.to_f + box9_37.to_f + box9_40.to_f)
end

print 'box9_1', box9_1
print 'box9_18', box9_18
print 'box9_20', box9_20
print 'box9_22', box9_22
print 'box9_41', box9_41
#
#-############################################################
#
# Main Form:
#
box2_31 = '%0.0f' % ( 1 + ( box2_25.strip.empty? ? 0 : 1 ) + ( box2_26.strip.empty? ? 0 : 1 ) + ( box2_27.strip.empty? ? 0 : 1 ) + ( box2_28.strip.empty? ? 0 : 1 ) + ( box2_29.strip.empty? ? 0 : 1 ) + ( box2_30.strip.empty? ? 0 : 1 ) )
print 'box2_31', box2_31

box2_57 = '%0.0f' % (box2_31.to_f + box2_32.to_f)
print 'box2_57', box2_57

box3_1 = box2_10
print 'box3_1', box3_1

box3_3 = ( box3_2.to_f > 0.0 ? 'X' : '' )
print 'box3_3', box3_3

#Note 11/11/10:There is a stipulation in the instructions if the user is not required to file a Federal return they skip to line 16 and enter
#a zero. Since the caution wants to see zeroes on every line we can't blank on this condition, the lines between 7 and 16 will show zeroes

#regardless.[12/18/12: Cannot locate the above mentioned stipulation in the instructions, but will follow the form itself, just like it is
# doing now...]

#
# Note 12/09/13: No current instructions. So following notes above and below
#

#Note 11/11/10:We can't post to line 7 from the Schedule E because the use may enter a value from their Federal forms.

#Note 11/11/10:If the user enters a value greater than zero on line 8A then they itemized their Federal deductions and
#we can calc. line 8B based on the amounts in the instructions. We need to default to zero here due to the caution where
#the user is suppose to enter a zero on each line.
box3_7 = if (box3_6.to_f > 0.0)
			case box2_23.to_i
				when 1,3 then '6100'
				when 2,5 then '12200'
				when 4 then '8950'
				else '0'
			end
		else '0'
		end
print 'box3_7', box3_7

#Note 11/11/10:Per instructions if the value on line 8C is less than zero print 0.

box3_8 = '%0.0f' % [box3_6.to_f - box3_7.to_f, 0.0].max
print 'box3_8', box3_8

#Note 11/11/10:We can't post the value from Shedule H to line 9 because the user may enter a value from their
#Federal form if they don't use schedule H. We can still check the box based on a value that is greater than zero
#as was done in the previous version. If the filer enters an amount from their federal form, they don't check the box. 

box3_9 = box8_41.to_f > 0.0 ? 'X' : ''
print 'box3_9', box3_9

box3_11 = '%0.0f' % [box3_5.to_f - box3_8.to_f - box3_10.to_f, 0.0].max
print 'box3_11', box3_11

box3_23 =  '%0.0f' % (box9_41)
print 'box3_23', box3_23

box3_24 = '%0.0f' % (box3_14.to_f + box3_15.to_f + box3_20.to_f + box3_21.to_f + box3_22.to_f + box3_23.to_f)
print 'box3_24', box3_24

box3_25 = '%0.0f' % [box3_12.to_f - box3_24.to_f, 0.0].max
print 'box3_25', box3_25

box3_29 = '%0.0f' % (box3_25.to_f + box3_28.to_f)
print 'box3_29', box3_29

# Note 12/09/13:The earlier notes below have been verified and are still applicable, any changes
# or updates will be indicated with a new note.

#Note 11/11/10:Per the specs. the name code is the first four positions of the last name, alpha and uppercase. If less than 4
#letters pad with spaces. Punctuation and hyphens should be omitted.
box3_30 = ( box2_8.upcase.delete("^A-Z ") + ' ' * 4 )[0,4]
print 'box3_30', box3_30

box4_1 = box2_10
print 'box4_1', box4_1

box4_12 = '%0.0f' % box8_38
print 'box4_12', box4_12

box4_19 = '%0.0f' % (box4_2.to_f + box4_9.to_f + box4_10.to_f + box4_11.to_f + box4_12.to_f + box4_13.to_f + box4_14.to_f + box4_17.to_f + box4_18.to_f)
print 'box4_19', box4_19

#There are numerous instructions for line 30 about entering zeros on other lines in certain cases.  Our standard calcs will return
#zeros on those lines and it's up to the user to follow the instructions and not enter amounts on lines they shouldn't.

box4_20 = '%0.0f' % [box4_19.to_f - box3_29.to_f, 0.0].max
print 'box4_20', box4_20
 
box4_23 = '%0.0f' % [box4_20.to_f - box4_22.to_f, 0.0].max
print 'box4_23', box4_23

#
#-############################################################
#
# Schedule D - Donation Schedule:
#
# blanking all fields on page refer to page 1 on calc. attch. 
#

if ( (box6_3 + box6_4 + box6_5 + box6_6 + box6_7 + box6_8 + box6_9 + box6_10 + box6_11 + box6_12 + box6_13 + box6_14 + box6_15 + box6_16 + box6_17 + box6_18 + box6_19 + box6_20 + box6_23 + box6_24 + box6_25 + box6_26 + box6_27 + box6_28).delete(" ").empty?)

	box6_1 = ''
	box6_2 = ''
	box6_21 = ''
else
	box6_1 = box2_10
	box6_2 =  box4_23
	box6_21 =  '%0.0f' % [box6_3.to_f + box6_4.to_f + box6_28.to_f + box6_5.to_f + box6_6.to_f + box6_7.to_f + box6_8.to_f + box6_9.to_f + box6_10.to_f + box6_11.to_f + box6_12.to_f + box6_13.to_f + box6_14.to_f + box6_15.to_f + box6_16.to_f + box6_17.to_f + box6_18.to_f + box6_19.to_f + box6_20.to_f + box6_23.to_f + box6_24.to_f + box6_25.to_f + box6_26.to_f + box6_27.to_f, box6_2.to_f].min
end

print 'box6_1', box6_1
print 'box6_2', box6_2
print 'box6_21', box6_21

#
#-############################################################
#

box4_24 =  '%0.0f' % (box6_21)
print 'box4_24', box4_24

#Note 11/12/10:As mentioned earlier, due to 2D not allowing zeroes we need to prevent negatives from showing.
box4_25 = '%0.0f' % [box4_23.to_f - box4_24.to_f, 0.0].max
print 'box4_25', box4_25

box4_28 = '%0.0f' % [box4_25.to_f - box4_26.to_f, 0.0].max
print 'box4_28', box4_28

#Name code post from page 2.
box4_29 = box3_30
print 'box4_29', box4_29

box5_1 = box2_10
print 'box5_1', box5_1

#Note 11/12/10:Per the instructions if line 18 is greater than 29 then print the result. If there was an underpayment
#which is line 31 greater than line 30, then that value goes on this line. The instructions then tells the user to
#to complete lines 38 - 41 and print zero on lines 42 - 45 and go to line 46. It is up to the user to enter zeroes on those
#specified lines.
box5_2 = '%0.0f' % if (box3_29.to_f > box4_19.to_f ) then box3_29.to_f - box4_19.to_f
				elsif (box4_22.to_f > box4_20.to_f) then box4_22.to_f - box4_20.to_f
				else 0
			end
print 'box5_2', box5_2

box5_12 = '%0.0f' % (box5_2.to_f + box5_3.to_f + box5_4.to_f + box5_5.to_f + box5_6.to_f + box5_27.to_f + box5_7.to_f + box5_8.to_f + box5_9.to_f  + box5_11.to_f)
print 'box5_12', box5_12

#
#-############################################################
#
# Status of Return Box - Per Calc Specs:
#
box5_13 = (box4_26.to_f > 0.0 ? '1' : '0') + (box4_28.to_f > 0.0 ? '1' : '0') + (box5_12.to_f > 0.0 ? '1' : '0')
print 'box5_13', box5_13

#
#-############################################################
#
# Contributions / Donations Status Box - Per Calc Specs:
#
box5_14 = (box4_24.to_f > 0.0 ? '1' : '0') + (box5_3.to_f > 0.0 ? '1' : '0') + (box5_4.to_f > 0.0 ? '1' : '0') + (box5_5.to_f > 0.0 ? '1' : '0') + (box5_6.to_f > 0.0 ? '1' : '0') + (box5_27.to_f > 0.0 ? '1' : '0')
print 'box5_14', box5_14

#Name code post from page 2.
box5_19 = box3_30
print 'box5_19', box5_19

#Note 11/11/10:Per the specs. the address code is the first four positions of the address including blank spaces. If less than 4
#characters pad with spaces. Punctuation and hyphens should be omitted. Since the form is field traited the address will always be
#upcased, but to make sure we upcase the address box anyway. 
box5_20 = ( box2_16.upcase.delete("^A-Z0-9 ") + ' ' * 4 )[0,4]
print 'box5_20', box5_20

#
# 12/09/13 - Addresses are the same as last year

#Note 11/12/10:The boxes under the header Mail to: Department of Revenue at the bottom of page 4 require us to soft code a P.O.
#box and address depending on whether the user has a tax due or refund. [12/18/12 Actually it is based on whether the Balance
# Due Louisiana line is 0 or greater than 0] Different P.O. boxes and addresses are used depending on which condition is found.
#The address portion for each is the same except for the last 4 digits of the zip code.

if (box5_12.to_f > 0.0)
	box5_23 = 'PO BOX 3550'
	box5_24 = 'BATON ROUGE LA 70821-3550'
else
	box5_23 = 'PO BOX 3440'
	box5_24 = 'BATON ROUGE LA 70821-3440'
end

print 'box5_23', box5_23
print 'box5_24', box5_24

#
#-############################################################
#
# Scanline:
#
# 12/09/13 - Only thing it changed in Scanline is Tax_period, the Document ID number and the CD that goes with Document ID

tax_period = '12312013'

pmt = '%010i' % (box5_12.to_i * 100)

primary_cd = check_digit(box2_10, 21, 10, true, true)
secondary_cd = check_digit(box2_15, 21, 10, true, true)
payment_cd = check_digit(pmt, 21, 10, true, true)

tax_type_code = (box5_12.to_f > 0.0 ? '663' : '664')  

# Note- the form number and form number check digit (fields A and B) aren't included in the fourth check digit
# [fourth counting from scan line element 'C', counting from 'A' would make it the fifth]. 

scanline_fields_c_to_k = '%09.0f' % ( box2_10.to_i ) + primary_cd.to_s + ' ' + tax_type_code + '  ' + tax_period + ' ' + '0' * 8 + ' ' + '%09.0f' % ( box2_15.to_i ) + secondary_cd.to_s + ' ' + pmt + payment_cd.to_s
fourth_cd = check_digit(scanline_fields_c_to_k.delete(' '), 21, 10, true, true)

box2_58 = '64592   ' + scanline_fields_c_to_k + ' ' + fourth_cd.to_s
print 'box2_58', box2_58

#
#-############################################################
#
# 2D BarCode:
#
# Caution: "Do not leave dollar fields blank (enter 0).". "If a field is not applicable, leave it blank unless
# specifically instructed otherwise." So given these rules [which seem at odds with one another] we can now
# let the zeroes show in the 2D. The 2D requirements also says to enter only whole dollar values. All of the 
# calcs. are rounded, but it is up to the user to enter rounded values in fields we don't calc. If the 2D rounded 
# the user entered fields we would be changing the values in the 2D from what the user has entered on the form.
# Also, no punctuation, hyphens, dashes, parenthesis, or other separators allowed. So for alpha fields we delete
# everything except letters, numbers, and spaces.
#
box5_26 = "T1\r1039\rLA\r6459\r0\r1\r1039\r" <<
box2_10 << "\r" <<
box2_15 << "\r" <<
box2_6.delete("^A-Z0-9 ")[0,25] << "\r" <<
box2_7.delete("^A-Z0-9 ")[0,1] << "\r" <<
box2_8.delete("^A-Z0-9 ")[0,25] << "\r" <<
box2_9.delete("^A-Z0-9 ")[0,3] << "\r" <<
box2_11.delete("^A-Z0-9 ")[0,25] << "\r" <<
box2_12.delete("^A-Z0-9 ")[0,1] << "\r" <<
box2_13.delete("^A-Z0-9 ")[0,25] << "\r" <<
box2_14.delete("^A-Z0-9 ")[0,3] << "\r" <<
box2_16.delete("^A-Z0-9 ")[0,35] << "\r" <<
box2_17.delete("^A-Z0-9 ")[0,25] << "\r" <<
box2_18.delete("^A-Z0-9 ")[0,2] << "\r" <<
box2_19.delete("^0-9")[0,9] << "\r" <<
box2_20.delete("^0-9")[0,10] << "\r" <<
'12312013' "\r" <<
'6459' "\r" <<
( box2_1.strip.empty? ? '0' : '1' ) << "\r" <<
( box2_2.strip.empty? ? '0' : '1' ) << "\r" <<
( box2_3.strip.empty? ? '0' : '1' ) << "\r" <<
( box2_4.strip.empty? ? '0' : '1' ) << "\r" <<
( box2_5.strip.empty? ? '0' : '1' ) << "\r" <<
box2_21 << "\r" <<
box2_22 << "\r" <<
box2_23 << "\r" <<
( box2_25.strip.empty? ? '0' : '1' ) << "\r" <<
( box2_26.strip.empty? ? '0' : '1' ) << "\r" <<
( box2_27.strip.empty? ? '0' : '1' ) << "\r" <<
( box2_29.strip.empty? ? '0' : '1' ) << "\r" <<
( box2_30.strip.empty? ? '0' : '1' ) << "\r" <<
box2_32 << "\r" <<
box2_57 << "\r" <<
# 12/15/11: State rejected this field as it was previously being calculated - we were using .to_i when 
# we should have just been passing the value into the 2D as-is. They siad it should have been blank, and
# an empty box converted to an int results in a zero being passed. The Analyst said that the
# corresponding NonResident form - IF passed by the state - should stay as is, even though it too
# is converting to an int via .to_i. They may not approve it though, so just pointing this out.
# Sounds strange, but that is what I was told.
box3_2 << "\r" <<
( box3_3.strip.empty? ? '0' : '1' ) << "\r" <<
( box3_4.strip.empty? ? '0' : '1' ) << "\r" <<
box3_5 << "\r" <<
box3_6 << "\r" <<
box3_7 << "\r" <<
box3_8 << "\r" <<
( box3_9.strip.empty? ? '0' : '1' ) << "\r" <<
box3_10 << "\r" <<
box3_11 << "\r" <<
box3_12 << "\r" <<
box3_13 << "\r" <<
box3_14 << "\r" <<
box3_15 << "\r" <<
box3_20 << "\r" <<
#Note:Since these codes are only 1 digt not going to worry about truncating.
box3_16 << "\r" <<
box3_17 << "\r" <<
box3_18 << "\r" <<
box3_19 << "\r" <<
box3_21 << "\r" <<
box3_22 << "\r" <<
box3_23 << "\r" <<
box3_24 << "\r" <<
box3_25 << "\r" <<
( box3_26.strip.empty? ? '2' : '1' ) << "\r" <<
box3_28 << "\r" <<
box3_29 << "\r" <<
box4_2 << "\r" <<
box4_3 << "\r" <<
box4_4 << "\r" <<
box4_9 << "\r" <<
box4_5 << "\r" <<
box4_6 << "\r" <<
box4_7 << "\r" <<
box4_8 << "\r" <<
box4_10 << "\r" <<
box4_11 << "\r" <<
box4_12 << "\r" <<
box4_13 << "\r" <<
box4_14 << "\r" <<
box4_17 << "\r" <<
box4_18 << "\r" <<
box4_19 << "\r" <<
box4_20 << "\r" <<
( box4_21.strip.empty? ? '0' : '1' ) << "\r" <<
box4_22 << "\r" <<
box4_23 << "\r" <<
box4_24 << "\r" <<
box4_25 << "\r" <<
box4_26 << "\r" <<
box4_27 << "\r" <<
box4_28 << "\r" <<
#
# 12/09/13 - this direct deposit part on page 4 is new in the 2D
#
if ( !box4_31.strip.empty?)
then '1'
elsif ( !box4_32.strip.empty? )
then '2'
else ''
end << "\r" <<
if ( !box4_33.strip.empty?)
then '1'
elsif ( !box4_34.strip.empty? )
then '0'
else ''
end << "\r" <<
box4_35.delete("^0-9")[0,9] << "\r" <<
box4_36.delete("^0-9")[0,17] << "\r" <<
box5_2 << "\r" <<
box5_3 << "\r" <<
box5_4 << "\r" <<
box5_5 << "\r" <<
box5_6 << "\r" <<
box5_27 << "\r" <<
box5_7 << "\r" <<
box5_8 << "\r" <<
box5_9 << "\r" <<
( box5_10.strip.empty? ? '0' : '1' ) << "\r" <<
box5_11 << "\r" <<
box5_12 << "\r" <<
box5_13 << "\r" <<
box5_14 << "\r" <<
box5_21 << "\r" <<
box5_19 << "\r" <<
box5_20 << "\r" <<
box5_22 << "\r" <<
# Shedule D
box6_2 << "\r" <<
box6_3 << "\r" <<
box6_4 << "\r" <<
box6_28 << "\r" <<
box6_5 << "\r" <<
box6_6 << "\r" <<
box6_7 << "\r" <<
box6_8 << "\r" <<
box6_9 << "\r" <<
box6_10 << "\r" <<
box6_11 << "\r" <<
box6_12 << "\r" <<
box6_13 << "\r" <<
box6_14 << "\r" <<
box6_15 << "\r" <<
box6_16 << "\r" <<
box6_17 << "\r" <<
box6_18 << "\r" <<
box6_19 << "\r" <<
box6_20 << "\r" <<
box6_23 << "\r" <<
box6_24 << "\r" <<
box6_25 << "\r" <<
box6_26 << "\r" <<
box6_27 << "\r" <<
box6_21 << "\r" <<
# 1/11/13 - schedule E thru schedule G are blank intill user enters something in area
# schedule E line 1 needs a if else statement to make it blank if blank or if schedule E filled either 0 or 1
#Shedule E
if sched_E_1
(box7_2.strip.empty? ? '0' : '1' ) 
else
''
end << "\r" <<
box7_3 << "\r" <<
box7_4 << "\r" <<
box7_5 << "\r" <<
box7_6 << "\r" <<
box7_8[0,3] << "\r" <<
box7_9 << "\r" <<
box7_11[0,3] << "\r" <<
box7_12 << "\r" <<
box7_14[0,3] << "\r" <<
box7_15 << "\r" <<
box7_17[0,3] << "\r" <<
box7_18 << "\r" <<
box7_20[0,3] << "\r" <<
box7_21 << "\r" <<
box7_23[0,3] << "\r" <<
box7_24 << "\r" <<
box7_26[0,3] << "\r" <<
box7_27 << "\r" <<
box7_29[0,3] << "\r" <<
box7_30 << "\r" <<
box7_31 << "\r" <<
box7_32 << "\r" <<
box7_33 << "\r" <<
box7_34 << "\r" <<
box7_35 << "\r" <<
box7_36 << "\r" <<
#Schedule F
box8_22 << "\r" <<
box8_24[0,3] << "\r" <<
box8_25 << "\r" <<
box8_27[0,3] << "\r" <<
box8_28 << "\r" <<
box8_30[0,3] << "\r" <<
box8_31 << "\r" <<
box8_33[0,3] << "\r" <<
box8_34 << "\r" <<
box8_36[0,3] << "\r" <<
box8_37 << "\r" <<
box8_38 << "\r" <<
#Schedule H
box8_39 << "\r" <<
box8_40 << "\r" <<
box8_41 << "\r" <<
#Schedule G
box9_2 << "\r" <<
box9_17 << "\r" <<
box9_18 << "\r" <<
box9_19 << "\r" <<
box9_20 << "\r" <<
box9_21 << "\r" <<
box9_22 << "\r" <<
box9_24[0,3] << "\r" <<
box9_25 << "\r" <<
box9_27[0,3] << "\r" <<
box9_28 << "\r" <<
box9_30[0,3] << "\r" <<
box9_31 << "\r" <<
box9_33[0,3] << "\r" <<
box9_34 << "\r" <<
box9_36[0,3] << "\r" <<
box9_37 << "\r" <<
box9_39[0,3] << "\r" <<
box9_40 << "\r" <<
box9_41 << "\r" <<
"*EOD*\r"
print 'box5_26', box5_26
